<template>
  <div>
    <ul class="catalog__list">
      <item v-for="item in pageItems" :item-data="item" :key="item.id"></item>
    </ul>
    <base-paginator :total-pages="totalPages" v-model="currentPage"></base-paginator>
  </div>
</template>

<script>
import Item from '@/components/catalog/Item.vue';
import BasePaginator from '@/components/helpers/BasePaginator.vue';

export default {
  name: 'item-list',
  props: ['items'],
  components: {
    Item,
    BasePaginator,
  },
  data() {
    return {
      currentPage: 1,
      itemsPerPage: 3,
    };
  },
  watch: {
    items() {
      this.currentPage = 1;
    },
  },
  computed: {
    pageItems() {
      return this.items.slice(this.offset, this.offset + this.itemsPerPage);
    },
    offset() {
      return (this.currentPage - 1) * this.itemsPerPage;
    },
    totalPages() {
      return Math.ceil(this.items.length / this.itemsPerPage);
    },
  },
};

</script>
